use strict;
use Getopt::Long;

require ("dc_check/dc_subs1.pl");
require ("dc_check/dc_version.pl");
#################### dc_contin.pl ###############xxx
#
# put together lines separated by \ (continuation lines)
# modify variable names to make them searchable
#
my ($result, $input, $output, $path, $version, $help);
our $donotchkvar;

$result = GetOptions (
    "input=s" => \$input, # string
    "path=s" => \$path, # string
    "output=s" => \$output, # string
    "version" => \$version, # string
    "donotchkvar=i" => \$donotchkvar, # string
    "help" => \$help); # flag

if ($version){
   our $dc_version;
   print "dc_contin.pl version=$dc_version\n";
   exit();
}

my (@output, $ol, $contin);
my ($r1, $r2, $r3, $r4, $r5, $r6, $r7);
$r1 = 'BSDollar';
$r2 = 'DHash';
$r3 = 'ABDollar';
$r4 = 'ABHash';
$r5 = 'Minus';
$r6 = 'Plus';
$r7 = 'Not';

my ($basename, $dirname, $b1name, $d1name, $slash, $fname, $oname);

($dirname, $slash, $fname) = get_fname($input, $path);
($d1name,$slash, $oname) = get_fname($output, $path);
#($dirname, $slash, $fname) = get_fname($ARGV[0], $ARGV[2]);
#($d1name,$slash, $oname) = get_fname($ARGV[1], $ARGV[2]);

#print "fname:$fname oname:$oname\n";

open FILE, "<$fname" or die 'Can\'t open '.$fname;
my @input = <FILE>;
close(FILE);


foreach(@input){
    chomp;
    if($_ =~ /(.*)\\\s*$/){
       #print "itt, $_\n";
       if($contin){
          $ol .= ' '.$1;
       }else{
          $ol = $1;
       }
       $contin = 1;
    } else{
      if($contin){
          $ol .= ' '.$_;
          $contin = 0;
          push(@output, $ol);
          $ol = '';
      } else{
          push(@output, $_);
      }
    }                
}

#
#  check brackets
#
check_brackets(\@output);

open FILE, ">", "$oname" or die 'Can\'t open '.$oname;
foreach(@output){
   # replace in agreement variables $=abc$ and #=abc 
   #   with $_abc$ and #_abc
   $_ =~ s/\$=([^ ]*)\$/\$_$1\$/g;
   $_ =~ s/\#=([^ ]*)\#/\#_$1\#/g;
   #
   # replace \$ and # with $r1 and $r2 in $..$ variables
   #
   my $out = modify_dollar_variables($_);
   #
   # replace $ and # with $r3 and $r4 in <..> variables
   #
   $out = modify_angle_bracket_variables($out);

   #
   #  redo $ variables for patterns like <$> $...\$...$
   #
   $out = modify_dollar_variables($out);

   # $out =~ s/$r3/g;  and
   # $out =~ s/$r4/g; would redo the modification

   #print "$out\n";
   print FILE "$out\n";
}
close(FILE);

sub modify_dollar_variables($)
{
   my ($out)= @_;
   my @arr1 = split(//, $out);
   my ($bs, $dollar);
   $out = '';
   foreach (@arr1){
     if($_ eq ' '){
       if($bs and $dollar){$out .= '\\'; $bs = 0;}
       $dollar = 0;
       $bs = 0;
       $out .= ' ';
     }
     elsif($_ eq '$'){
        if($dollar and $bs){
           $out .= $r1;
           $bs = 0;
        } 
        elsif($dollar){$dollar = 0; $out .= '$';}
        else {$dollar = 1;  $out .= '$';}   
     }     
     elsif($_ eq '#'){
        if($bs and $dollar){$out .= '\\'; $bs = 0;}
        if($dollar ){
           $out .= $r2;
        } 
        else { $out .= '#';}   
     }
     elsif($_ eq '-'){
        if($bs and $dollar){$out .= '\\'; $bs = 0;}
        if($dollar ){
           $out .= $r5;
        } 
        else { $out .= '-';}   
     }elsif($_ eq '+'){
        if($bs and $dollar){$out .= '\\'; $bs = 0;}
        if($dollar ){
           $out .= $r6;
        } 
        else { $out .= '+';}   
     }elsif($_ eq '^'){
        if($bs and $dollar){$out .= '\\'; $bs = 0;}
        if($dollar ){
           $out .= $r7;
        } 
        else { $out .= '^';}   
     }
     elsif ($_ eq '\\'){
        if($dollar){$bs = 1;}
        else {$out .= '\\';}
     } else{
       if($bs and $dollar){$out .= '\\'; $bs = 0;}
       $out .= $_;
     }
   }
   return $out;
}

sub modify_angle_bracket_variables($){
   my ($out)= @_;
   my @arr1 = split(//, $out);
   my ($bs, $dollar);
   $out = '';
   foreach (@arr1){
     if($_ eq ' '){
       $dollar = 0;
       $bs = 0;
       $out .= ' ';
     }
     elsif($_ eq '$'){
        if($dollar){
           $out .= $r3;
        } 
        else {$out .= '$';}   
     } 
     elsif($_ eq '#'){
        if($dollar){
           $out .= $r4;
        } 
        else {$out .= '#';}  
     } 
     elsif($_ eq '-'){
        if($dollar){
           $out .= $r5;
        } 
        else {$out .= '-';} 
     }
     elsif($_ eq '+'){
        if($dollar){
           $out .= $r6;
        } 
        else {$out .= '+';} 
     }
     elsif($_ eq '^'){
        if($dollar){
           $out .= $r7;
        } 
        else {$out .= '^';} 
     }     
     elsif ($_ eq '>'){
        $dollar = 0;
        $out .= '>';
     } elsif ($_ eq '<'){
        $dollar = 1;
        $out .= '<';
     } else{
       $out .= $_;
     }
   }
   return $out;
}