use strict;
use Getopt::Long;
require ("dc_check/dc_subs1.pl");
require ("dc_check/dc_version.pl");


my ($result, $input, $output, $path, $version, $help);
our $donotchkvar;

$result = GetOptions (
    "input=s" => \$input, # string
    "path=s" => \$path, # string
    "output=s" => \$output, # string
    "version" => \$version, # string
    "donotchkvar=i" => \$donotchkvar, # string
    "help" => \$help); # flag

if ($version){
   our $dc_version;
   print "dc_osszefuz.pl version=$dc_version\n";
   exit();
}

#################### dc_osszefuz.pl ###############xxx
#
# exclude comments
# include includes, protect against recursing includes
#
my (@output, @arr, @f_included);
my ($basename, $dirname, $b1name, $d1name, $slash, $fname, $oname);
my $debug = 0;

($dirname, $slash, $fname) = get_fname($input, $path);
($d1name,$slash, $oname) = get_fname($output, $path);

open FILE, "<$fname" or die 'Can\'t open '.$fname;
my @input = <FILE>;
close(FILE);


foreach(@input){
   chomp;
   if($_ =~ /^#include\s+"(.*)"/){
      my $ret = include_file($1);
      my @ret_arr = @$ret;
      foreach(@ret_arr){
        push(@output, $_);
      }
   } else{
      @arr = split(/%/, $_);
      if(length($arr[0])){
        push(@output, $arr[0]);
      }
   }
}

open FILE, ">", "$oname" or die 'Can\'t open '.$oname;
foreach(@output){
   print FILE "$_\n";
}
close(FILE);

#
# recursively read in include files
#  refuse recursing includes: a includes b, and b includes a, looping for ever
#      
sub include_file($){
   my ($fname) = @_;
   my $bname = basename($fname);
   my (@output, @read_lines);
   foreach(@f_included){
     if($_ =~ /$bname/){
       print STDERR "Warning: File $bname fn:$fname stored:$_ included recursively\n";
       return \@output;
     }
    }
    push(@f_included, $fname);
    my ($f1name, $d1name);
    $d1name = dirname($fname);
    if($d1name eq ''){
        $f1name = $dirname.$slash.$fname;
    }else{
        $f1name = $fname;
    }
    my $b1name = basename($f1name);
    my $res = open FILE, "$f1name";
    if(!$res){
      open FILE, "$b1name" or die $f1name." ".$b1name;
    }
    @read_lines = <FILE>;
    close FILE;
      foreach(@read_lines){
      chomp;
      @arr = split(/%/, $_);
       if(length($arr[0])){
        if($arr[0] =~ /^#include\s+"(.*)"/){
         my $ret = include_file($1);
         my @ret_arr = @$ret;
           foreach(@ret_arr){
            push(@output, $_);
           }
        } else{
            push(@output, $arr[0]);
            if($debug){
             print "$fname: $arr[0]\n";
            }
        }
       }
      } 
      return \@output;
 }    


