use strict;

our (@arr, $as, $folytatas, %barr, %b2arr, @b1arr, %b3arr, %carr, $was_alphabet, %repl, @darr);
our (@input, $donotchkvar);
sub print_message($);
sub print_message_v($);

#$donotchkvar = 1;  # uncomment this to use dc_check with SMOR

#
#  check if opening and closing brackets match per line
#  check for backslash before <=> or ^->
#
# Name sanity checks:
#--------------------
# complain if $ , #, (,),[,],{,or }  in <..>  variable name
# complain if # <>, (,),[,],{,or } in $..$ variable name
# complain if $ or <>, (,),[,],{,or }  in #..# variable name
#
sub check_brackets($)
{
   my ($inp) = @_;
   my @input = @$inp;
my ($linenr,  @def_arr, $sda, $out, $out1, $debug);
$debug = 0;
 foreach(@input){
   ++$linenr;
   my ($curly, $parent, $square, $angle, $bs, $dollar, $hash);
   chomp;
  while ($_ =~ /<=>/g){
    check_for_backslash($`, $linenr);
  }
  while ($_ =~ /\^\->/g){
    check_for_backslash($`, $linenr);
   }
  my $line = eliminate_unpaired_angle_brackets($_);
  #print "line:$line\n";
  my @arr = split(//, $line);
  my $as = @arr;
  my $ix = 0;
  foreach(@arr){
      if($_ eq '('     ){
          if($dollar){print_message_v "Warning, ( in \$..\$ variable name near line $linenr\n";}
          if($hash){print_message_v "Warning, ( in #..# variable name near line $linenr\n";}
        if($angle) {print_message_v "Warning, ( in <..> variable near line $linenr\n";}
        ++$parent;
     } elsif($_ eq '['){
        ++$square;
         if($dollar){print_message_v "Warning, [ in \$..\$ variable name near line $linenr\n";}
          if($hash){print_message_v "Warning, [ in #..# variable name near line $linenr\n";}
        if($angle) {print_message_v "Warning, [ in <..> variable near line $linenr\n";}
     } elsif($_ eq '{'){
         if($dollar){print_message_v "Warning, { in \$..\$ variable name near line $linenr\n";}
          if($hash){print_message_v "Warning, { in #..# variable name near line $linenr\n";}
        if($angle) {print_message_v "Warning, { in <..> variable near line $linenr\n";}
        ++$curly;
     } elsif($_ eq ')'){
         if(!$parent){print_message_v "Warning, sequence starts with ) near line $linenr\n";}
        --$parent;
         if($dollar){print_message_v "Warning, ) in \$..\$ variable name near line $linenr\n";}
          if($hash){print_message_v "Warning, ) in #..# variable name near line $linenr\n";}
        if($angle) {print_message_v "Warning, ) in <..> variable near line $linenr\n";}
     } elsif($_ eq ']'){
         if(!$square){print_message_v "Warning, sequence starts with ] near line $linenr\n";}
        --$square;
         if($dollar){print_message_v "Warning, ] in \$..\$ variable name near line $linenr\n";}
          if($hash){print_message_v "Warning, ] in #..# variable name near line $linenr\n";}
        if($angle) {print_message_v "Warning, ] in <..> variable near line $linenr\n";}
      } elsif($_ eq '}'){
         if(!$curly){print_message_v "Warning, sequence starts with } near line $linenr\n";}
        --$curly;
         if($dollar){print_message_v "Warning, } in \$..\$ variable name near line $linenr\n";}
          if($hash){print_message_v "Warning, } in #..# variable name near line $linenr\n";}
        if($angle) {print_message_v "Warning, } in <..> variable near line $linenr\n";}
     } elsif($_ eq '<'){
       #if($arr[$ix +1] ne ' ' and $arr[$ix +1] ne '=' and $arr[$ix +1] ne '-'){
          if($angle){print_message_v "Warning, nested < vars near line $linenr\n";}
          ++$angle;
          if($dollar){print_message_v "Warning, < in \$..\$ variable name near line $linenr\n";}
          if($hash){print_message_v "Warning, < in #..# variable name near line $linenr\n";}
       #}
     } elsif($_ eq '>'){
       if($ix == 0){print_message_v "Warning, sequence starts with > near line $linenr\n";}
       #if($arr[$ix -1] ne ' ' and $arr[$ix -1] ne '=' and $arr[$ix -1] ne '-'  and $arr[$ix -1] ne '>'){
          if($angle == 0){print_message_v "Warning, sequence starts with > near line $linenr\n";}
          else{
          --$angle;
          }
          if($dollar){print_message_v "Warning, > in \$..\$ variable name near line $linenr\n";}
          if($hash){print_message_v "Warning, > in #..# variable name near line $linenr\n";}
       #}
     } elsif($_ eq '$'){
        if($dollar) {$dollar = 0;}
        else {$dollar = 1;}
        if($angle){print_message_v "Warning, \$ in <..> variable name near line $linenr\n";}
        if($hash){print_message_v "Warning, \$ in #..# variable name near line $linenr\n";}
     } elsif($_ eq '#'){
        if($hash) {$hash = 0;}
        else {$hash = 1;}
        if($angle){print_message_v "Warning, # in <..> variable name near line $linenr\n";}
        if($dollar){print_message_v "Warning, # in \$..\$ variable name near line $linenr\n";}
     } elsif($_ eq ' '){
        if($angle) {print_message "Warning, blank in <..> variable near line $linenr\n";}
        if($dollar) {print_message "Warning, blank in dollar variable near line $linenr\n";}
        if($hash) {print_message "Warning, blank in #..# variable near line $linenr\n";}
     }
     ++$ix;
  } # foreach arr
 if($curly> 0){print_message "Warning, missing \}. near line $linenr\n";}
 if($curly< 0){print_message "Warning, too many \}-s l near line $linenr\n";}
 if($parent> 0){print_message"Warning, missing ), near line $linenr\n";}
 if($parent< 0){print_message "Warning, too many )-s, near line $linenr\n";}
 if($square> 0){print_message "Warning, missing ],  near line $linenr\n";}
 if($square< 0){print_message "Warning, too many ]-s,  near line $linenr\n";}
 if($hash> 0){print_message_v "Warning, missing \#,  near line $linenr\n";}
 if($hash< 0){print_message_v "Warning, too many \#-s,  near line $linenr\n";}
 if($angle> 0){print "Warning, missing >, near line $linenr\n";}
 if($angle< 0){print "Warning, too many >-s, near line $linenr\n";}
 }# foreach input 
} # sub
#
# collect transducers, 
#  check for using undefined transducers
#
sub check_transducers1()
{
my ($linenr,  @def_arr, $sda, $out, $out1, $debug);
$debug = 0;
foreach(@input){
   ++$linenr;
   chomp;
  my ($l0, $l1,@list, @list0, @list1);
  my $current = $_;
  my @arr = split(/=/, $current);
  my $as = @arr;
  if($arr[0] =~  /\$([^ ]*)/){
     @list = ($arr[0] =~ /\$([^ ]*)/g);
     foreach(@list){
         my $ix = is_in($_, '$');
         if($ix != -1){
             my $seg = substr($_,0,$ix);
             push(@list0, $seg);
         }
     }
  }   
  if(defined($arr[1]) and $arr[1] =~  /\$([^ ]*)/){
     @list = ($arr[1] =~ /\$([^ ]*)/g);
     foreach(@list){
         my $ix = is_in($_, '$');
         if($ix != -1){
             my $seg = substr($_,0,$ix);
             push(@list1, $seg);
         }
     }
  }  
  $l0 = @list0;
  $out = '';
  $out1 = '';
  $sda = @def_arr;
  if($debug>2){
    my $sds = @def_arr;
    if($sds){
     print "line:$current sda:@def_arr\n";
    }
  }
  if($sda){
   for(my $i = 0; $i < $sda; $i++){
     my $elem = $def_arr[$i];
     $out1 .= '_'.$elem;
   }
   $out1 .= '_';
  }
 if($l1){
   for(my $i = 0; $i < $l1; $i++){
     my $elem = $list1[$i];
     $out .= '_'.$elem;
     if($out1 !~ /$elem/ and $as > 1 ){
           print_message( "Warning: using undefined transducer $elem near line $linenr\n"); 
     }
   }
   $out .= '_';
  }
  #print "l0:$l0 as:$as $current\n";
 if($l0 and $as < 2){
   for(my $i = 0; $i < $l0; $i++){
     my $elem = $list0[$i];
     $out .= '_'.$elem;
     if($out1 !~ /$elem/ ){
           print_message( "Warning: using undefined transducer $elem near line $linenr\n"); 
     }
   }
   $out .= '_';
  }
  # fill defined transducer list
 if($l0 > 1 or  $l1> 0){
  if($debug>3){print "line:$linenr cur:$current as:$as l1:$l0 l1:$l1 darr:@def_arr out:$out\n";}
 }
  if($as > 1 and $l0 ){
    for(my $i = 0; $i < $l0; $i++){
      my $elem = $list0[$i];
      my $elem1 = '_'.$elem.'_';
      if($out !~ /$elem1/ ){
         my $found;
         foreach(@def_arr){
           if($_ eq $elem){ $found = 1; last; }
         }
         if(!$found) {
           push(@def_arr,$elem);
           if($debug>3){print "after add $elem in def_arr: @def_arr\n";}
           #foreach(@def_arr){
           #   print "after add in def_arr: $_\n";
           #}
         } #found 
       } # ($out !~ /$elem1/)
     } # for $i 
   } #$as > 1 and $l0
 } # foreach input   
}
#
# check for redefined transducers
#
sub check_transducers2(){
my ($linenr,  @def_arr, $out,  $debug);
foreach(@input){
   ++$linenr;
   chomp;
  my ($l0, $l1,@list, @list0, @list1);
  my $current = $_;
  my @arr = split(/=/, $current);
  my $as = @arr;
  if($arr[0] =~  /\$([^ ]*)/){
     @list = ($arr[0] =~ /\$([^ ]*)/g);
     foreach(@list){
         my $ix = is_in($_, '$');
         if($ix != -1){
             my $seg = substr($_,0,$ix);
              push(@list0, $seg);
         }
     }
  }   
  if(defined($arr[1]) and $arr[1] =~  /\$([^ ]*)/){
     @list = ($arr[1] =~ /\$([^ ]*)/g);
     foreach(@list){
         my $ix = is_in($_, '$');
         if($ix != -1){
             my $seg = substr($_,0,$ix);
             push(@list1, $seg);
         }
     }
  }  
  $l0 = @list0;
  $l1 = @list1; 
  $out = '';
  if($l1){
   for(my $i = 0; $i < $l1; $i++){
     my $elem = $list1[$i];
     $out .= '_'.$elem;
   }
   $out .= '_';
  }
  # fill defined transducer list
 if($l0 > 1 or  $l1> 0){
  if($debug>3){print "line:$linenr cur:$current as:$as l1:$l0 l1:$l1 darr:@def_arr out:$out\n";}
 }
  if($as > 1 and $l0 ){
    for(my $i = 0; $i < $l0; $i++){
      my $elem = $list0[$i];
      my $elem1 = '_'.$elem.'_';
      if(good($out) and good($elem1) and $out !~ /$elem1/ ){
         my $found;
         foreach(@def_arr){
           if($_ eq $elem){ $found = 1; last; }
         }
         if(!$found) {
           push(@def_arr,$elem);
           if($debug>3){print "after add $elem in def_arr: @def_arr\n";}
           #foreach(@def_arr){
           #   print "after add in def_arr: $_\n";
           #}
         } #found 
         else{
           print_message( "Warning: transducer $elem redefined near line $linenr\n"); 
         } # else
      } # ($out !~ /$elem1/)
     } # for $i 
   } #$as > 1 and $l0
  if($as > 1 and $l0 and $l1){
  # empty def_arr transducer list
    my (@seg_arr);
    for(my $i = 0; $i < $l1; $i++){
      my $elem = $list1[$i];
      if($debug>3){print "search for $elem in @def_arr list1:@list1 l0:$l0 l1:$l1 \n";}
      foreach(@def_arr){
          if($_ eq $elem){ 
             push(@seg_arr, $elem);
             if($debug>3){print "added $elem to @seg_arr\n";}
          } 
       }
     } # $i
     if($debug>2){print "remove @seg_arr from @def_arr new def-arr:@def_arr\n";}
     my $adefarr = remove_element_from_array(\@def_arr, \@seg_arr);
     @def_arr = @$adefarr;
   } # $l0 and $l1 
   elsif($as <=1 and $l0){
    my (@seg_arr);
    for(my $i = 0; $i < $l0; $i++){
      my $elem = @list0[$i];
         my $found = -1;
         foreach(@def_arr){
           if($_ eq $elem){ 
              if($debug>3){print "2. remove from def_arr $elem\n";}
             push(@seg_arr, $elem);
             $found = $i;
             last;
           }
         }
         if($found != -1) {
           my $adefarr = remove_element_from_array(\@def_arr, \@seg_arr);
          @def_arr = @$adefarr;
          if($debug>2){print "2.new def-arr:@def_arr\n";}
         }
      } # $i
    } # $l0 only
   my $dnr = @def_arr;
   if($dnr){
   # print "line $linenr def_arr:@def_arr\n";
   }
} # foreach input   
#
# print result for unused transducers
#  
$out = '';
my ($cnt, $var);
$var = "transducer";
foreach(@def_arr){
   $out .= '$'.$_.'$ ';
   if(++$cnt > 1){$var = "transducers";}
}
if($out ne ''){
   print_message( "Warning: unused $var: $out\n");
}
}
#
# utility for unused transducers
# remove elements of arref, that are contained in sref
#
sub remove_element_from_array($$){
    my ($arref, $sref) = @_;
    my @def_arr = @$arref;
    my @seg_arr = @$sref;
    my @seg1_arr;
    my $sa = @seg_arr;
    my ($found, $debug);
    if($debug){print "sa:$sa da:@def_arr\n";}
    if($sa) {
       foreach(@def_arr){
             my $elem = $_;
             $found = 0;
             foreach(@seg_arr){
              if ($_ eq $elem){
                 $found =1;
              }
           }
           if(!$found){
              push(@seg1_arr, $elem);
           }
         }
         @def_arr = @seg1_arr;
         @seg1_arr = ();
     }
     return \@def_arr;
}
#
#  check for variables starting with $ or # also end with $ or #
#
sub check_variables()
{
my $linenr = 0;
foreach(@input){
   ++$linenr;
   chomp;
  my $current = $_;
  if($current =~  /#([^ ]*)/){
     my @list = ($current =~ /#([^ ]*)/g);
     foreach(@list){
          if(is_in($_, '#') == -1){
          print_message( "Warning: variable \#$_ name starting with \# and not ending with \#: \#$_ near to line $linenr \n");
         }
     }
  }
  if($current =~  /\$([^ ]*)/){
     my @list = ($current =~ /\$([^ ]*)/g);
     foreach(@list){
        # print "element:$_ last:$last\n";
         if(is_in($_, '$') == -1){
          print_message( "Warning: variable \$$_ name starting with \$ and not ending with \$: \$$_ near to line $linenr \n");
         }
     }
  }   
}
}
#
# is element in a string- because of $ must be this complicated
#
sub is_in($$){
   my ($elem, $char)=@_;
   my @arr = split(//,$elem);
   my $ix;
   foreach(@arr){
     if($_ eq $char){ return $ix;}
     ++$ix;
   }
   return -1;
} 
#
# Print messages. Make sure, a certain message will not be repeated. 
#
my %messages;
sub print_message($){
  my ($msg) = @_;
  if(defined($messages{$msg})){return;}
  $messages{$msg} = 1;
  print "$msg";
  return;
}
sub print_message_v($){
  if($donotchkvar < 1){return;}
  my ($msg) = @_;
  if(defined($messages{$msg})){return;}
  $messages{$msg} = 1;
  print "$msg";
  return;
}

#
#  replace all #name# variables with the fullest version
#    result in hash %repl
#
sub replace_hvariable_names(){
my $debug = 0;
foreach(@input){
   chomp;
   if($_ =~ /#(.*?)#\s*=\s*(.*?)\s*$/){
        my $seg2 = $2;
        my $seg1 = $1;
        my ($name, $elements);
        while (($name, $elements) = each(%repl))
        {
          my $seg3 = '#'.$name.'#';
          if($debug> 1){
            print "seg3:'$seg3' name:'$name' seg2:'$seg2' seg1:'$seg1' line:'$_'\n";
          }
          if($seg2 =~ /$seg3/){
             $seg2 =~ s/$seg3/$elements/;
             if($debug > 1){
              print "repl in $seg2  $seg3 with $elements\n";
             }
           }
        }
        if(good($seg1) and good($seg2)){
           $repl{$seg1} = $seg2;
             if($debug){
               print "add to repl $seg1 $seg2\n";
             }
        }
   }
}
}
#
#  check if argument contains unmatched brackets, if yes,
#    this can not be checked as regular expression
#
sub good($){
  my ($var) = @_;
  my @arr = split(//, $var);
  my ($b1, $b2, $b3);
  foreach(@arr){
   if($_ eq '('){
       {++$b1;
       };
   }elsif($_ eq ')'){
      if($b1) {
          --$b1;
       }
      else {return 0;}
   }elsif($_ eq '{'){
       {++$b2;};
   }elsif($_ eq '}'){
      if($b2) {--$b2;}
      else {return 0;}
   }elsif($_ eq '['){
       {++$b3;
        return 0;  # w/o return crashes
       };
   }elsif($_ eq ']'){
      if($b3) {--$b3;
        # return 0; 
       }
      else {return 0;}
   }
  }
  if(!$b1 and !$b2 and !$b3) {
    return 1;}
  else {return 0;}
}
#
#  collect all inflection variables in array @darr
#
sub collect_inflection_vars_in_darr(){
foreach(@input){
   chomp;
   if($_ =~ /{?<(.*)>}?:{(.*)}\s*$/){
     #print "1:$1 2:$2 l:$_\n";
     my $seg = $2;
     if($2 =~ /<(.*)>/){
        #print "in 2 $2  seg:$seg\n";
        $seg =~ s/>[a-záéóúűőüöí]*</ /g;
        $seg =~ s/>[a-záéóúűőüöí]*\s*$/ /g;
        #print "in 2 $1  seg:$seg\n";
        $seg =~ s/</ /g;
        #print "in 2 $1  seg:$seg l:$_\n";
        my @arr = split(/\s+/, $seg);
        foreach(@arr){
           my $seg1 = $_;
           my $found = 0;
          foreach(@darr){
            if($_ eq $seg1){$found = 1; last;}
          }
          if(!$found and $_ ne ''){
              push(@darr, $_); 
          }
        } #@arr
     } # if $2
   } # if $_
}
}
#
# Return the directory portion of a path (minus the filename)
# Like File::Basename::dirname
#
sub dirname
{
   my $path = shift @_;
   if ($path =~ m-[\\/][^\\/]+$-)
   {
      return $`;
   }
   "";
}
#
# Return the last portion of a path
# Like File::Basename::basename
#
sub basename
{
   my $path = shift @_;
   if ($path =~ m-([^\\/]+)$-)
   {
      return $1;
   }
   "";
}
#
#  file name from arguments
#
sub get_fname($$){
  my ($argv0, $argv1) = @_;
  #print "gf $argv0 $argv1\n";

  my $osname = $^O;
  my $slash = '/';
  if( $osname eq 'MSWin32' ){
     $slash = '\\';
  }
 
  my ($basename, $dirname);
  $basename = basename($argv0);
  $dirname = dirname($argv0);
  chomp $dirname;
  chomp $basename;
  if($dirname eq ''){
     $dirname = $argv1;
     if($dirname eq ''){
       print "get_fname filename pwd\n";
       exit();
     }
  }
  my $fname = $dirname.$slash.$basename;
  return ($dirname, $slash, $fname);
}
sub check_for_backslash($$){
   my ($prev, $linenr) = @_;
   if(substr($prev, -1,1) eq '\\'){
        print_message "Warning, backslash before <=> near line $linenr\n";
    } 
    if(substr($prev, -2,1) eq '\\'){
        print_message "Warning, backslash before <=> near line $linenr\n";
    } 
}

sub eliminate_unpaired_angle_brackets($){
 my ($line) = @_;
 my $debug = 0;
if ($line =~ s/\^\->/___/g){
  if($debug){print "1match $line\n";}
}
if ($line =~ s/\^=>/___/g){
  if($debug){print "9match $line\n";}
}
if ($line =~ s/\^<=>/___/g){
  if($debug){print "11match $line\n";}
}
if ($line =~ s/\^<=/___/g){
  if($debug){print "10match $line\n";}
}
if ($line =~ s/_=>/___/g){
  if($debug){print "12match $line\n";}
}
if ($line =~ s/_<=>/___/g){
  if($debug){print "14match $line\n";}
}
if ($line =~ s/_<=/___/g){
  if($debug){print "13match $line\n";}
}
if ($line =~ s/<=>/___/g){
  if($debug){print "4match $line\n";}
}if ($line =~ s/<=/__/g){
  if($debug){print "2match $line\n";}
}
if ($line =~ s/=>/__/g){
  if($debug){print "3match $line\n";}
}
if ($line =~ s/>>/__/g){
  if($debug){print "5match $line\n";}
}
if ($line =~ s/<</__/g){
  if($debug){print "5.1match $line\n";}
}
if ($line =~ s/_\->/___/g){
  if($debug){print "6match $line\n";}
}
if ($line =~ s/\/\->/___/g){
  if($debug){print "7match $line\n";}
}
if ($line =~ s/\\->/___/g){
  if($debug){print "8match $line\n";}
}
return $line;
}

sub read_evars($$$){
  my ($darr,$harr, $aarr) = @_;
  my $efile = "dc_check/dc_vars.txt";
  if(-e $efile){
     open FILE, "<$efile" or die $!;
     my @lines = <FILE>;
     close FILE;
     foreach(@lines){
     if(substr($_,0,1) eq '#'){next;}
      if($_ =~ /L\$\s*:/){
        my @arr = split(/:/, $_);
        my @arr1 = split(/\s+/, $arr[1]);
        foreach(@arr1){
          $darr .= $_.' ';
        }
      } # dollar
      if($_ =~ /L\#\s*:/){
        my @arr = split(/:/, $_);
        my @arr1 = split(/\s+/, $arr[1]);
        foreach(@arr1){
          $harr .= $_.' ';
        }
      } # hash
      if($_ =~ /L\<\s*:/){
        my @arr = split(/:/, $_);
        my @arr1 = split(/\s+/, $arr[1]);
        foreach(@arr1){
          $aarr .= $_.' ';
        }
      } # arrow brace
     } # lines
  }  # -e file
  return ($darr, $harr, $aarr);
} # sub

1;